=== debian/changelog ===
libsbml (5.18.0+dfsg-2) unstable; urgency=medium

  * Do not attempt to build on several architectures
    Closes: #953584
  * Add salsa-ci file (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 11 Mar 2020 09:53:46 +0100
